'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var commonConfig = require('frontful-common/config');
var resolve = require('../../utils/resolve');

module.exports = function provider(options) {
  options = (0, _extends3.default)({
    debug: false
  }, options);

  return {
    babelrc: false,
    ignore: new RegExp('node_modules/(?!(' + commonConfig.packages.join('|') + '))'),
    presets: [['babel-preset-env', {
      targets: {
        node: 6
      },
      include: ['transform-es2015-classes'],
      modules: 'commonjs',
      loose: false,
      useBuiltIns: false,
      debug: options.debug
    }], 'babel-preset-react'].map(resolve),
    plugins: ['babel-plugin-transform-decorators-legacy', 'babel-plugin-add-module-exports', 'babel-plugin-transform-class-properties', 'babel-plugin-transform-object-assign', 'babel-plugin-transform-object-rest-spread', ['babel-plugin-transform-runtime', {
      helpers: true,
      polyfill: true,
      regenerator: true,
      moduleName: 'babel-runtime'
    }]].map(resolve)
  };
};