'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

exports.default = run;

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _tmp = require('tmp');

var _tmp2 = _interopRequireDefault(_tmp);

var _transpile = require('./utils/transpile');

var _transpile2 = _interopRequireDefault(_transpile);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function run(options) {
  options = (0, _extends3.default)({
    transpile: true,
    folder: null,
    root: '.'
  }, options);

  var packages = [options.root];
  var packagesPath = _path2.default.resolve(process.cwd(), options.folder || '.');

  if (options.folder) {
    packages = _fsExtra2.default.readdirSync(packagesPath).filter(function (file) {
      return _fsExtra2.default.statSync(_path2.default.join(packagesPath, file)).isDirectory();
    });
  }

  packages.forEach(function (pkg) {
    var sourcePath = _path2.default.resolve(packagesPath, pkg);

    var temp = _tmp2.default.dirSync({
      unsafeCleanup: true
    });

    var tempPath = temp.name;
    var targetPath = _path2.default.resolve(sourcePath, 'build');

    _fsExtra2.default.removeSync(targetPath);

    _fsExtra2.default.copySync(sourcePath, tempPath, {
      filter: function filter(filename) {
        return (/^((?!(\/(\.npmrc|\.node-version|\.hash|npm-debug\.log|yarn-error\.log|\.git|node_modules|build|yarn\.lock)(\/|$))).)*$/i.test(filename)
        );
      }
    });

    _fsExtra2.default.copySync(tempPath, targetPath);

    temp.removeCallback();

    if (options.transpile) {
      (0, _transpile2.default)(targetPath);
    }

    console.log(_chalk2.default.green.bold('Package built (' + pkg + ')'));
  });
}
module.exports = exports.default;