'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _find = require('find');

var _find2 = _interopRequireDefault(_find);

var _crypto = require('crypto');

var _crypto2 = _interopRequireDefault(_crypto);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Hash = function () {
  function Hash(sourcePath, buildPath) {
    var _this = this;

    (0, _classCallCheck3.default)(this, Hash);

    this.generate = function () {
      var files = _find2.default.fileSync(/^((?!(\/(\.npmrc|\.node-version|\.hash|npm-debug\.log|yarn-error\.log|\.git|node_modules|yarn\.lock)(\/|$))).)*$/i, _this.basePath).sort();
      var hash = _crypto2.default.createHash('sha1');

      files.forEach(function (file) {
        var fileIdentifier = file.replace(_this.basePath, '').replace(/\\|\//gi, '>');
        hash.write(fileIdentifier + _fsExtra2.default.readFileSync(file, 'utf8'));
      });

      return hash.digest('base64');
    };

    this.sourcePath = _path2.default.resolve(process.cwd(), sourcePath);
    this.basePath = buildPath ? _path2.default.resolve(process.cwd(), buildPath) : process.cwd();
    this.value = '';
    this.file = _path2.default.resolve(this.basePath, '.hash');
    _fsExtra2.default.ensureFileSync(this.file);
    this.read();
  }

  (0, _createClass3.default)(Hash, [{
    key: 'read',
    value: function read() {
      this.value = _fsExtra2.default.readFileSync(this.file, 'utf8');
      return this.value;
    }
  }, {
    key: 'changed',
    value: function changed() {
      return this.generate() !== this.value;
    }
  }, {
    key: 'update',
    value: function update() {
      this.write(this.generate());
    }
  }, {
    key: 'write',
    value: function write(hash) {
      _fsExtra2.default.writeFileSync(_path2.default.resolve(this.sourcePath, '.hash'), hash);
      this.value = hash;
    }
  }]);
  return Hash;
}();

exports.default = Hash;
module.exports = exports.default;