'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PackageJSON = function () {
  function PackageJSON(rootPath) {
    (0, _classCallCheck3.default)(this, PackageJSON);

    this.filePath = _path2.default.resolve(rootPath, 'package.json');
  }

  (0, _createClass3.default)(PackageJSON, [{
    key: 'lock',
    value: function lock() {
      var content = _fs2.default.readFileSync(this.filePath, 'utf8');
      content = content.replace('"private": false', '"private": true');
      _fs2.default.writeFileSync(this.filePath, content);
    }
  }, {
    key: 'unlock',
    value: function unlock() {
      var content = _fs2.default.readFileSync(this.filePath, 'utf8');
      content = content.replace('"private": true', '"private": false');
      _fs2.default.writeFileSync(this.filePath, content);
    }
  }, {
    key: 'bump',
    value: function bump() {
      var content = _fs2.default.readFileSync(this.filePath, 'utf8');

      var version = content.match(/"version": "(.+)"/i)[1];
      var arr = version.split('.').map(function (part) {
        return parseInt(part, 10);
      });
      version = arr[0] + '.' + arr[1] + '.' + (arr[2] + 1);

      content = content.replace(/"version": ".+"/i, '"version": "' + version + '"');

      _fs2.default.writeFileSync(this.filePath, content);

      return version;
    }
  }]);
  return PackageJSON;
}();

exports.default = PackageJSON;
module.exports = exports.default;